Subject: tty programming for modems and fax
From: [email-masked] (Michael Anderson)

27 May 1997 20:09:20 -0700
Approved: [email-masked]
Distribution: cygnus
Message-ID: <[email-masked]>
References: <[email-masked]>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 7bit
X-Mailer: Mozilla 3.01 (X11; I; Linux 2.0.12 i586)
Original-To: [email-masked]
Original-Sender: [email-masked]

I installed B18 and discovered that most of the
tty (serial port) stuff doesn't seem to work.
I therefore downloaded the B18 source and
discovered that the features were not implemented!

Do I have the wrong source or is no one else
trying to do tty programming with cygwin?

In any case, I've spent the last coupla' days
implementing what I needfor my projects. In
particular, I have the following functionality
coded and awaiting through testing:

open() supports O_NDELAY and O_NONBLOCK in the
	2nd argument. I also added the third
	argument, mode, for future implementation.

fcntl() supports toggling of blocking and
	non-blocking I/O modes with O_NDELAY and
	O_NONBLOCK.

tcgetattr() previously handled CBAUD (all speeds),
	CSIZE, ONLCR, and VTIME and VMIN for c_cc[].
	New support is for CSTOPB, PARENB, PARODD,
	INPCK, IGNPAR, IXON, IXOFF, CRTSXOFF, CRTSCTS,
	and VSTART and VSTOP for c_cc[].

tcsetattr() previously handled CBAUD, CSIZE, PARENB, 
	PARODD, IGNCR, ONLCR, and VTIME and VMIN for
	c_cc[]. New support is for CSTOPB, INPCK,
	IGNPAR, IXON, IXOFF, CRTSXOFF, CRTSCTS, and
	VSTART and VSTOP for c_cc[]. TCSANOW,
	TCSADRAIN, and TCSAFLUSH arguments are
	implemented.

tcsendbreak() is implemented.

tcdrain() is implemented.

tcflow() is implemented.

I'm still working on CREAD and CLOCAL for tc[gs]etattr().
Many other flags such as HUPCL may have no reasonable
implementation.

If anybody else cares about this stuff and has code
which could be used to test it, that would be great.
I'm only using a subset for my current project and
as usual, am way behind, and don't have time to do
testing or much more development.

Regards, Mike Anderson
[email-masked]
-
For help on using this list (especially unsubscribing), send a message to
"[email-masked]" with one line of text: "help".